local BM_BAGSTATUS_ID = "bmbagstatus_";
function BM_Bag_Status_OnLoad()	
	this:RegisterEvent("VARIABLES_LOADED");
	PLUG_IN_FRAME = "BM_Bag_Status";
	PLUG_IN_NAME = "BM Bag Status";
	BM_ICON_SIZE = BAG_STATUS_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_ICON_SIZE,BM_BAGSTATUS_ID);
end

function BM_Bag_Status_OnEvent(event)	
	if (event == "VARIABLES_LOADED") then
		this:RegisterEvent("UNIT_MODEL_CHANGED");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		BM_Bag_Status_initialize();
		BM_Bag_Status_OnShow();
	end

	if (event == "PLAYER_ENTERING_WORLD") then
		this:RegisterEvent("BAG_UPDATE");
		this:RegisterEvent("ITEM_LOCK_CHANGED");
		this:RegisterEvent("PLAYER_LEAVING_WORLD");
	end

	if (event == "PLAYER_LEAVING_WORLD") then
		this:UnregisterEvent("BAG_UPDATE");
		this:UnregisterEvent("ITEM_LOCK_CHANGED");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
	end

	BM_Bag_Status_Refresh();
end

function BM_Bag_Status_initialize()
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmbagstatus_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmbagstatus_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmbagstatus_ShowLabelText == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmbagstatus_ShowLabelText = true;
	end
end

function BM_Bag_Status_Refresh()
	local bm_total_bags = 0;
	local bm_count_used_slots = 0;
	local bm_status_bar_color = 0;
	local bm_total_slots_bag = 0;
	local bm_slots_bag = 0;
	local bm_bag_name = "";
	local bm_bag_slot_count = 1;
	local bag_text = "";
	local labelText = "";
	for bm_slots_bag = 0, 4, 1 do
		bm_is_ammo = false;
		bm_total_slots_bag = 0;
		bm_bag_name = GetBagName(bm_slots_bag);
		if (bm_bag_name ~= nil) then
			for i = 0, table.getn(BM_IS_AMMO_BAG), 1 do
				if (string.find(BM_IS_AMMO_BAG[i], bm_bag_name)) then
					bm_is_ammo = true;
				end
			end
			if (bm_is_ammo == false) then
				bm_total_bags = bm_total_bags + GetContainerNumSlots(bm_slots_bag);
				bm_total_slots_bag = GetContainerNumSlots(bm_slots_bag);
			end
			for bm_bag_slot_count = 1, bm_total_slots_bag, 1 do
				if (GetContainerItemInfo(bm_slots_bag, bm_bag_slot_count) and bm_is_ammo == false) then
					bm_count_used_slots = bm_count_used_slots + 1;
				end
			end
		end
	end
	--Sets the text color.
	bm_status_bar_color = (bm_count_used_slots/bm_total_bags)*100;
	if (bm_status_bar_color >= 0 and bm_status_bar_color <= 50) then
		if (TitanGetVar(BM_BAGSTATUS_ID, "usedfree")) then
			bag_text = format(BAG_STATUS_TEXT_GREEN, bm_count_used_slots, bm_total_bags);
		else
			bag_text = format(BAG_STATUS_TEXT_GREEN, (bm_total_bags-bm_count_used_slots), bm_total_bags);
		end
	elseif (bm_status_bar_color >= 51 and bm_status_bar_color <= 75) then
		if (TitanGetVar(BM_BAGSTATUS_ID, "usedfree")) then
			bag_text = format(BAG_STATUS_TEXT_YELLOW, bm_count_used_slots, bm_total_bags);
		else
			bag_text = format(BAG_STATUS_TEXT_YELLOW, (bm_total_bags-bm_count_used_slots), bm_total_bags);
		end
	elseif (bm_status_bar_color >= 76 and bm_status_bar_color <= 100) then
		if (TitanGetVar(BM_BAGSTATUS_ID, "usedfree")) then
			bag_text = format(BAG_STATUS_TEXT_RED, bm_count_used_slots, bm_total_bags);
		else
			bag_text = format(BAG_STATUS_TEXT_RED, (bm_total_bags-bm_count_used_slots), bm_total_bags);
		end
	else
		if (TitanGetVar(BM_BAGSTATUS_ID, "usedfree")) then
			bag_text = format(BAG_STATUS_TEXT_WHITE, bm_count_used_slots, bm_total_bags);
		else
			bag_text = format(BAG_STATUS_TEXT_WHITE, (bm_total_bags-bm_count_used_slots), bm_total_bags);
		end
	end
	if (TitanGetVar(BM_BAGSTATUS_ID, "ShowLabelText")) then
		BM_Bag_StatusText:SetText(BAG_STATUS_LABEL_BAGS .. bag_text);
	else
		BM_Bag_StatusText:SetText(bag_text);
	end
end

function BM_Bags_OnClick(button)
	if (button == "LeftButton") then
		OpenAllBags();
	end
end

function BM_Bag_Status_OnShow()
	BM_Bag_Status_SetIcon();
end

function BM_Bag_Status_SetIcon()
	local icon = BM_Bag_StatusIcon;
	if (TitanGetVar(BM_BAGSTATUS_ID, "ShowIcon")) then
		icon:SetTexture(BM_IMAGE_PATH .. "Icon_bag");
		icon:SetWidth(BAG_STATUS_ICON_SIZE);
		icon:SetHeight(BAG_STATUS_ICON_SIZE);
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
end


---**** Options ****---
local BMBagStatus_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;
local ctext3 = BM_BAGS_FREE_USED;
BMBagStatus_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmbagstatus_ShowIcon",
	pSlashCommand = "BMBagStatus_Check1_Opt"
};
BMBagStatus_CheckButtons[ctext2] = {
	id = 2,
	strVar = "bmbagstatus_ShowLabelText",
	pSlashCommand = "BMBagStatus_Check2_Opt"
};
BMBagStatus_CheckButtons[ctext3] = {
	id = 3,
	strVar = "bmbagstatus_usedfree",
	pSlashCommand = "BMBagStatus_Check3_Opt"
};

function BMBagStatus_Check1_Opt(msg)
	TitanSetVar(BM_BAGSTATUS_ID, "ShowIcon", msg);
	BM_Bag_Status_SetIcon();
	BM_Bag_Status_Refresh();
end

function BMBagStatus_Check2_Opt(msg)
	TitanSetVar(BM_BAGSTATUS_ID, "ShowLabelText", msg);
	BM_Bag_Status_Refresh();	
end
function BMBagStatus_Check3_Opt(msg)
	TitanSetVar(BM_BAGSTATUS_ID, "usedfree", msg);
	BM_Bag_Status_Refresh();
end

function BM_Bag_Status_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMBagStatus_CheckButtons do
		button = getglobal("BMBagStatus_Check" .. value.id);
		string = getglobal("BMBagStatus_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end