local BM_EST_ID = "bmest_";
function BM_Est_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_LEVEL_UP");
	
	PLUG_IN_FRAME = "BM_Est";
	PLUG_IN_NAME = "BM Estimated To Level";
	BM_ICON_SIZE = BM_EST_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_ICON_SIZE, BM_EST_ID);
end

function BM_Est_OnEvent(event)	
	if (event == "VARIABLES_LOADED") then		
		BM_EST_initialize();
		BM_XP_START = UnitXP("player");
		BM_XP_CURRENT = UnitXP("player");
		return;
	end
	if (event == "UNIT_NAME_UPDATE") then				
		BM_XP_START = UnitXP("player");
		BM_XP_CURRENT = UnitXP("player");
		return;
	end 
	if (event == "PLAYER_ENTERING_WORLD") then
		BM_XP_START = UnitXP("player");
		BM_XP_CURRENT = UnitXP("player");
		BM_Est_OnShow();
		return;
	end

	if (event == "PLAYER_XP_UPDATE") then
		if (event ~= "PLAYER_LEVEL_UP") then
			BM_XP_CURRENT = UnitXP("player");
			BM_XP_GAIN = BM_XP_CURRENT - BM_XP_START;
			BM_XP_START = BM_XP_CURRENT;
			BM_XP_TOTAL = BM_XP_TOTAL + BM_XP_GAIN;
			BIB_TOTALXP_SESSION = BIB_TOTALXP_SESSION + BM_XP_GAIN;
		end
	end

	if (event == "PLAYER_LEVEL_UP") then
		BM_XP_CURRENT = UnitXP("player");
		BM_XP_GAIN = (BM_XP_MAX - BM_XP_START) + BM_XP_CURRENT;
		BM_XP_START = BM_XP_CURRENT;
		BM_XP_TOTAL = BM_XP_TOTAL + BM_XP_GAIN;
		BIB_TOTALXP_SESSION = BIB_TOTALXP_SESSION + BM_XP_GAIN;
		BM_XP_MAX = UnitXPMax("player");
	end
end

function BM_EST_initialize()
	if (not BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS]) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS] = {};
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_xp == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_xp = 0;
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_time = 0;
		BM_XP_TOTAL = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_xp;
		BM_TIME_TOTAL = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_time;
	else
		BM_XP_TOTAL = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_xp;
		BM_TIME_TOTAL = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_time;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmest_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmest_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmest_ShowLabel == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmest_ShowLabel = true;
	end
	BM_Est_OnShow();
end

function BM_Est_OnUpdate(arg1)
	BM_EST_REFRESH = BM_EST_REFRESH + arg1;
	if (BM_EST_REFRESH > BM_EST_DELAY) then
		BM_EST_REFRESH = 0.0;
		BM_Est_Refresh();
		BIB_Est_GetTooltipText();
	end
end

function BM_Est_Refresh()
	-- Creates estimated time to level.
	local tolevel = 0;
	local check_day_hour_min = "";
	BM_XP_MAX = UnitXPMax("player");
	BM_XP_TO_LEVEL = BM_XP_MAX - BM_XP_START;
	BM_TIME_TOTAL = BM_TIME_TOTAL + 1;
	BM_XP_PER_HOUR = BM_XP_TOTAL / (BM_TIME_TOTAL/3600);
	if (BM_XP_TOTAL == 0) then
		BM_EST_TO_LEVEL = "NAN";
		BM_EstText:SetText(format(NO_ESTIMATED_TEXT_WHITE, BM_EST_TO_LEVEL));
	else				
		BM_EST_TO_LEVEL = BM_XP_TO_LEVEL/BM_XP_PER_HOUR;
		if (BM_EST_TO_LEVEL > 24) then
			tolevel = BM_EST_TO_LEVEL/24;
			if (tolevel < 2) then
				check_day_hour_min = BM_EST_DAY;
			else
				check_day_hour_min = BM_EST_DAYS;
			end
		elseif (BM_EST_TO_LEVEL < 1) then
			tolevel = BM_EST_TO_LEVEL*60;
			if (tolevel < 2) then
				check_day_hour_min = BM_EST_MIN;
			else
				check_day_hour_min = BM_EST_MINS;
			end
		else
			tolevel = BM_EST_TO_LEVEL;
			if (tolevel < 2 ) then
				check_day_hour_min = BM_EST_HOUR;
			else
				check_day_hour_min = BM_EST_HOURS;
			end
		end
		if (TitanGetVar(BM_EST_ID, "ShowLabel")) then
			BM_EstText:SetText(BM_EST_LABEL .. format(ESTIMATED_TEXT_WHITE, tolevel, check_day_hour_min));
		else
			BM_EstText:SetText(format(ESTIMATED_TEXT_WHITE, tolevel, check_day_hour_min));
		end
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_xp = BM_XP_TOTAL;
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Est_total_time = BM_TIME_TOTAL;
	end
	return
end

function BIB_Est_GetTooltipText()
	local max_xp	= BM_XP_MAX;
	local xpgained = BM_XP_CURRENT;
	local xpneeded = BM_XP_MAX - BM_XP_CURRENT;
	local xpgainedsession = BIB_TOTALXP_SESSION;
	local restedxp = GetXPExhaustion();
	local restedxppercent = 0;
	local xpperhour = BM_XP_PER_HOUR;
	if (restedxp == nil) then
		restedxppercent = 0;
	else
		restedxppercent = (restedxp/max_xp)*100;
	end
	BIB_EST_TOOLTIP_TEXT = ""..
							BIB_EST_TOOLTIP_MAX_XP .. "\t" .. BM_WHITE .. format(BIB_EST_FORMAT1, max_xp) .. BM_FONT_OFF .. "\n" ..
							BIB_EST_TOOLTIP_XP_GAINED .. "\t" ..  BM_WHITE .. format(BIB_EST_FORMAT1, xpgained) .. BM_FONT_OFF  .. "\n" ..
							BIB_EST_TOOLTIP_XP_NEEDED .. "\t" ..  BM_WHITE .. format(BIB_EST_FORMAT1, xpneeded) .. BM_FONT_OFF  .. "\n" .. 
							BIB_EST_TOOLTIP_XP_GAIN_SESSION .. "\t" ..  BM_WHITE .. format(BIB_EST_FORMAT1, xpgainedsession) .. BM_FONT_OFF  .. "\n" ..
							BIB_EST_TOOLTIP_RESTED_XP .. "\t" ..  BM_WHITE .. format(BIB_EST_FORMAT2, restedxppercent) .. BM_FONT_OFF  .. "\n" ..
							BIB_EST_TOOLTIP_XPPERHOUR .. "\t" ..  BM_WHITE .. format(BIB_EST_FORMAT1, xpperhour) .. BM_FONT_OFF ;
end

function BM_Est_OnShow()
	BM_Est_SetIcon();
end

function BM_Est_SetIcon()
	local icon = BM_EstIcon;
	local factionGroup, factionName = UnitFactionGroup("player");			
	if (TitanGetVar(BM_EST_ID, "ShowIcon")) then
		if ( factionGroup == "Alliance" ) then
			icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-Alliance");
			icon:SetTexCoord(0.046875, 0.609375, 0.03125, 0.59375);
			icon:SetWidth(BM_EST_ICON_SIZE);
			icon:SetHeight(BM_EST_ICON_SIZE);
		elseif ( factionGroup == "Horde" ) then
			icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-Horde");
			icon:SetTexCoord(0.046875, 0.609375, 0.015625, 0.578125);
			icon:SetWidth(BM_EST_ICON_SIZE);
			icon:SetHeight(BM_EST_ICON_SIZE);
		else
			icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA");
			icon:SetTexCoord(0.046875, 0.609375, 0.03125, 0.59375);
			icon:SetWidth(BM_EST_ICON_SIZE);
			icon:SetHeight(BM_EST_ICON_SIZE);
		end
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
end


---**** Options ****---
local BMEst_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;

BMEst_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmest_ShowIcon",
	pSlashCommand = "BMEst_Check1_Opt"
};
BMEst_CheckButtons[ctext2] = {
	id = 2, 
	strVar = "bmest_ShowLabel",
	pSlashCommand = "BMEst_Check2_Opt"
};

function BMEst_Check1_Opt(msg)
	TitanSetVar(BM_EST_ID, "ShowIcon", msg);
	BM_Est_SetIcon();
	BM_Est_Refresh();
end

function BMEst_Check2_Opt(msg)
	TitanSetVar(BM_EST_ID, "ShowLabel", msg);
	BM_Est_Refresh();
end

function BM_Est_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMEst_CheckButtons do
		button = getglobal("BMEst_Check" .. value.id);
		string = getglobal("BMEst_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end

function BIB_Est_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	-- set the tool tip text
	GameTooltip:SetText(BM_GREEN .. BIB_EST_TOOLTIP_TITLE .. BM_FONT_OFF);
	BM_Tooltip_AddTooltipText(BIB_EST_TOOLTIP_TEXT);
	GameTooltip:Show();
end

function  BIB_Est_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end