--[[
	IB_MiniDPS: by Shake Ported by Bhaldie
]]
-- main infobar display, player dps
IB_MINIDPS_PITHY_LIST = {
    "DPS: pwn w/ez",
    "DPS: nerf shamans",
    "DPS: <3 rogues",
    "DPS: omgwtfkthxbye",
};
-- the following strings that must 
-- be localized for functionality.
IB_MINIDPS_HUNTER = "Hunter"; 
IB_MINIDPS_WARLOCK = "Warlock";

--------------------------------------------------------
-- local variables
--------------------------------------------------------
local BM_MINIDPS_ID = "bmminidps_";
local nextUpdate = 0;
local localState;
local class;
local isCombat;

-- per combat stats
local startTime = 0;
local endTime = 0;
local playerDmgOut = 0;
local playerDmgIn = 0;
local petDmgOut = 0;
local playerDpsOut = 0;
local playerDpsIn = 0;
local petDpsOut = 0;
local peakPlayerDmgOut = 0;
local peakPlayerDmgIn = 0;

-- per session stats
local totalTime = 0;
local totalPlayerDmgOut = 0;
local totalPlayerDmgIn = 0;
local totalPetDmgOut = 0;
local totalPlayerDpsOut = 0;
local totalPlayerDpsIn = 0;
local totalPetDpsOut = 0;
local sessionPeakPlayerDmgOut = 0;
local sessionPeakPlayerDmgIn = 0;

BM_HAS_PET = false;

local function IB_MiniDPS_IsPetEnabled()
	local player_class = "";
	local pet_enabled = false;
	plaer_class = UnitClass("player");
	if (player_class == IB_MINIDPS_HUNTER or player_class == IB_MINIDPS_WARLOCK and PetHasActionBar() == true) then
		BM_HAS_PET = true;
	else
		BM_HAS_PET = false;
	end
	return
end

local function IB_MiniDPS_GetCombatDuration()
    local delta = (endTime - startTime);
    if (delta <= 0) then
        delta = 0.046;
    end
    return delta;
end

local function IB_MiniDPS_UpdateCurrentStats()
    local dur = IB_MiniDPS_GetCombatDuration();
    playerDpsOut = playerDmgOut/dur;
    playerDpsIn = playerDmgIn/dur;
    petDpsOut = petDmgOut/dur;
    if (playerDpsOut > 30000) then
        BM_MiniDPSText:SetText(IB_MINIDPS_PITHY_LIST[random(1,4)]);
    else
	if (TitanGetVar(BM_MINIDPS_ID, "ShowLabel")) then
		BM_MiniDPSText:SetText(BM_MINIDPS_LABEL .. format(IB_MiniDPS_TEXT, playerDpsIn, playerDpsOut));
	else
		BM_MiniDPSText:SetText(format(IB_MiniDPS_TEXT, playerDpsIn, playerDpsOut));
	end
    end
end

local function IB_MiniDPS_UpdateSessionStats()
    totalTime = totalTime + IB_MiniDPS_GetCombatDuration();

    totalPlayerDmgOut = totalPlayerDmgOut + playerDmgOut;
    totalPlayerDmgIn = totalPlayerDmgIn + playerDmgIn;
    totalPetDmgOut = totalPetDmgOut + petDmgOut;

    sessionPeakPlayerDmgOut = max(sessionPeakPlayerDmgOut, peakPlayerDmgOut);
    sessionPeakPlayerDmgIn = max(sessionPeakPlayerDmgIn, peakPlayerDmgIn);

    totalPlayerDpsOut = totalPlayerDmgOut/totalTime;
    totalPlayerDpsIn = totalPlayerDmgIn/totalTime;
    totalPetDpsOut = totalPetDmgOut/totalTime;
end

local function IB_MiniDPS_ResetCombatStats()
    playerDmgOut = 0;
    playerDmgIn = 0;
    peakPlayerDmgOut = 0;
    peakPlayerDmgIn = 0;
    petDmgOut = 0;
end

local function IB_MiniDPS_StartCombat()
    if (not isCombat) then
        isCombat = 1;
        startTime = GetTime();
        IB_MiniDPS_ResetCombatStats();
    end
end

local function IB_MiniDPS_EndCombat()
    if (isCombat) then
        isCombat = nil;
        IB_MiniDPS_UpdateCurrentStats();
        IB_MiniDPS_UpdateSessionStats();
    end
end

local function IB_MiniDPS_UpdatePlayerStatsOut(dmg)
    IB_MiniDPS_StartCombat(); 
    endTime = GetTime();
    playerDmgOut = playerDmgOut + dmg;
    peakPlayerDmgOut = max(peakPlayerDmgOut, dmg);
end

local function IB_MiniDPS_UpdatePlayerStatsIn(dmg)
    IB_MiniDPS_StartCombat(); 
    endTime = GetTime();
    playerDmgIn = playerDmgIn + dmg;
    peakPlayerDmgIn = max(peakPlayerDmgIn, dmg);
end

local function IB_MiniDPS_UpdatePetStatsOut(dmg)
    IB_MiniDPS_StartCombat();    
    endTime = GetTime();
    petDmgOut = petDmgOut + dmg;
end

local function IB_MiniDPS_UpdateSettings()
    if (localState.delay < 2) then
        localState.delay = 2;
    end

    if (IB_MiniDPS_IsPetEnabled()) then
        IB_MiniDPS:RegisterEvent("CHAT_MSG_COMBAT_PET_HITS"); 
	    IB_MiniDPS:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE");
    else
        IB_MiniDPS:UnregisterEvent("CHAT_MSG_COMBAT_PET_HITS"); 
	    IB_MiniDPS:UnregisterEvent("CHAT_MSG_SPELL_PET_DAMAGE");
    end
end

function IB_MiniDPS_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");

	this:RegisterEvent("CHAT_MSG_COMBAT_PET_HITS"); 
	this:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE");
      
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");

	this:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS"); 
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE"); 
	this:RegisterEvent("CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF"); 
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE"); 

	this:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS"); -- creature direct dmg
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"); -- creature spell dmg
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS"); -- hostile player direct melee dmg
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE"); -- hostile player direct spell dmg
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"); -- hostile player dot dmg from melee and spells
	PLUG_IN_FRAME = "BM_MiniDPS";
	PLUG_IN_NAME = "MiniDPS";
	BM_ICON_SIZE = BM_MINIDPS_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_ICON_SIZE, BM_MINIDPS_ID);
end

function IB_MiniDPS_OnEvent(event)
    if (event == "VARIABLES_LOADED") then		
		BM_MiniDPS_initialize();
		if (TitanGetVar(BM_MINIDPS_ID, "ShowLabel")) then
			BM_MiniDPSText:SetText(BM_MINIDPS_LABEL .. format(IB_MiniDPS_TEXT, 0, 0));
		else
			BM_MiniDPSText:SetText(format(IB_MiniDPS_TEXT, 0, 0));
		end
		return;
	end
    if (event == "PLAYER_REGEN_DISABLED") then
        IB_MiniDPS_StartCombat();
    elseif (event == "PLAYER_REGEN_ENABLED") then
        IB_MiniDPS_EndCombat();

    elseif (event == "CHAT_MSG_COMBAT_SELF_HITS"
         or event == "CHAT_MSG_SPELL_DAMAGESHIELDS_ON_SELF") then
        local i, j, val = string.find(arg1, "(%d+)");
        if ( val and (not strfind(arg1, "You fall and lose")) ) then
            IB_MiniDPS_UpdatePlayerStatsOut(val);
        end

    elseif (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
        local i, j, val = string.find(arg1, "(%d+)");
        if (val and (not strfind(string.lower(arg1), "mana"))) then
            IB_MiniDPS_UpdatePlayerStatsOut(val);
        end

    elseif (event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS"
         or event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE"
         or event == "CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS"
         or event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE"
         or event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
        local i, j, val = string.find(arg1, "(%d+)");
        if (val) then
            IB_MiniDPS_UpdatePlayerStatsIn(val);
        end

    elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") then
        if (strfind(string.lower(arg1), "your")) then
            local i, j, val = string.find(arg1, "(%d+)");
            if (val) then
                IB_MiniDPS_UpdatePlayerStatsOut(val);
            end
        end

    elseif (event == "CHAT_MSG_COMBAT_PET_HITS" 
         or event == "CHAT_MSG_SPELL_PET_DAMAGE") then
        local i, j, val = string.find(arg1, "(%d+)");
        if (val) then
            IB_MiniDPS_UpdatePetStatsOut(val);
        end
    end
end

function BM_MiniDPS_initialize()
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmminidps_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmminidps_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmminidps_ShowLabel == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmminidps_ShowLabel = true;
	end
	BM_MiniDPS_OnShow();
end

function IB_MiniDPS_OnUpdate(arg1)
	BM_MINIDPS_REFRESH = BM_MINIDPS_REFRESH + arg1;
	if (BM_MINIDPS_REFRESH > BM_MINIDPS_DELAY) then
		--[[
		if (BM_MiniDPS:GetWidth() ~= BM_MiniDPSText:GetWidth()+BM_MINIDPS_ICON_SIZE) then
			BM_MiniDPS:SetWidth(BM_MiniDPSText:GetWidth()+BM_MINIDPS_ICON_SIZE);
			
			Refresh_Plugins();
		end
		--]]
		if (not isCombat) then
			return;
		else
			IB_MiniDPS_UpdateCurrentStats();
		end
		BM_MINIDPS_REFRESH = 0.0;
	end
end

function BM_IB_MiniDPS_OnEnter()
	if (PetHasActionBar()) then
		BM_DPS_TOOLTIP_TEXT = format(IB_MiniDPS_TOOLTIP_P_TEXT, playerDpsIn, playerDpsOut, peakPlayerDmgIn, peakPlayerDmgOut, petDpsOut, totalPlayerDpsIn, totalPlayerDpsOut, sessionPeakPlayerDmgIn, sessionPeakPlayerDmgOut, totalPetDpsOut);
	else
		BM_DPS_TOOLTIP_TEXT = format(IB_MiniDPS_TOOLTIP_NP_TEXT, playerDpsIn, playerDpsOut, peakPlayerDmgIn, peakPlayerDmgOut, totalPlayerDpsIn, totalPlayerDpsOut, sessionPeakPlayerDmgIn, sessionPeakPlayerDmgOut);
	end
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	GameTooltip:SetText(IB_MiniDPS_TOOLTIP_TITLE);
	BM_Tooltip_AddTooltipText(BM_DPS_TOOLTIP_TEXT);
	GameTooltip:Show();
end

function BM_IB_MiniDPS_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end

function BM_MiniDPS_OnShow()
	BM_MiniDPS_SetIcon();
end

function BM_MiniDPS_SetIcon()
	local icon = BM_MiniDPSIcon;
	if (TitanGetVar(BM_MINIDPS_ID, "ShowIcon")) then
		icon:SetTexture(BM_IMAGE_PATH .. "Icon_minidps");
		icon:SetWidth(BM_MINIDPS_ICON_SIZE);
		icon:SetHeight(BM_MINIDPS_ICON_SIZE);
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
		
end

---**** Options ****---
local BMMiniDPS_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;

BMMiniDPS_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmminidps_ShowIcon",
	pSlashCommand = "BMMiniDPS_Check1_Opt"
};
BMMiniDPS_CheckButtons[ctext2] = {
	id = 2, 
	strVar = "bmminidps_ShowLabel",
	pSlashCommand = "BMMiniDPS_Check2_Opt"
};

function BMMiniDPS_Check1_Opt(msg)
	TitanSetVar(BM_MINIDPS_ID, "ShowIcon", msg);
	BM_MiniDPS_SetIcon();
	IB_MiniDPS_UpdateCurrentStats();
end

function BMMiniDPS_Check2_Opt(msg)
	TitanSetVar(BM_MINIDPS_ID, "ShowLabel", msg);
	IB_MiniDPS_UpdateCurrentStats();
end

function BM_MiniDPS_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMMiniDPS_CheckButtons do
		button = getglobal("BMMiniDPS_Check" .. value.id);
		string = getglobal("BMMiniDPS_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end