local BM_MONEY_ID = "BMMoney_";
local startMoney;
function BM_Money_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_MONEY");
	this:RegisterEvent("PLAYER_TRADE_MONEY");
	this:RegisterEvent("TRADE_MONEY_CHANGED");
	this:RegisterEvent("SEND_MAIL_MONEY_CHANGED");
	this:RegisterEvent("SEND_MAIL_COD_CHANGED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	PLUG_IN_FRAME = "BM_Money";
	PLUG_IN_NAME = "BM Money";
	BM_ICON_SIZE = BAG_STATUS_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_MONEY_ICON_SIZE, BM_MONEY_ID);
	WoW_OpenCoinPickupFrame = OpenCoinPickupFrame;	
	OpenCoinPickupFrame = BM_OpenCoinPickupFrame;
end


function BM_Money_OnEvent()
	if (event == "VARIABLES_LOADED") then		
		BM_Money_initialize();
		return;
	end
	if ( event == "PLAYER_ENTERING_WORLD" and BM_MONEY_TYPE == "PLAYER" ) then
		if (not startMoney) then
			startMoney = GetMoney();
		end
		BM_Money_Refresh();
		BIBMoney_GetTooltipText();
	elseif ( event == "PLAYER_MONEY" and BM_MONEY_TYPE == "PLAYER" ) then
		BM_Money_Refresh();
		BIBMoney_GetTooltipText();
	elseif ( event == "PLAYER_TRADE_MONEY" and (BM_MONEY_TYPE == "PLAYER" or BM_MONEY_TYPE == "PLAYER_TRADE") ) then
		BM_Money_Refresh();
		BIBMoney_GetTooltipText();
	elseif ( event == "TRADE_MONEY_CHANGED" and BM_MONEY_TYPE == "TARGET_TRADE" ) then
		BM_Money_Refresh();
		BIBMoney_GetTooltipText();
	elseif ( event == "SEND_MAIL_MONEY_CHANGED" and (BM_MONEY_TYPE == "PLAYER" or BM_MONEY_TYPE == "SEND_MAIL") ) then
		BM_Money_Refresh();
		BIBMoney_GetTooltipText();
	elseif ( event == "SEND_MAIL_COD_CHANGED" and (BM_MONEY_TYPE == "PLAYER" or BM_MONEY_TYPE == "SEND_MAIL_COD") ) then
		BM_Money_Refresh();
		BIBMoney_GetTooltipText();
	end
	
end

function BM_Money_initialize()
	BM_Gold:Show();
	BM_Silver:Show();
	BM_Copper:Show();
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BMMoney_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BMMoney_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BMMoney_ShowLabel == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BMMoney_ShowLabel = true;
	end
	BM_Money_OnShow();
end

function BM_Money_Refresh()
	local money = GetMoney();
	local gold = floor(money / (COPPER_PER_SILVER * SILVER_PER_GOLD));
	local silver = floor((money - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER);
	local copper = mod(money, COPPER_PER_SILVER);
	BM_GoldText:SetText(gold);
	BM_SilverText:SetText(silver);
	BM_CopperText:SetText(copper);
end

function BIBMoney_GetTooltipText() 
	local initialMoney = startMoney;
	local fluctMoney = GetMoney() - initialMoney;
		
	-- Current money Text
	local currentMoneyRichText = BIB_MONEY_TOOLTIP_CURRENT.."\t"..
			TitanUtils_GetHighlightText(format(BIB_MONEY_FORMAT, BIBMoney_OutPutMoney(GetMoney())));

	-- Initial money Text
	local initialMoneyRichText = BIB_MONEY_TOOLTIP_INITIAL.."\t"..
			TitanUtils_GetHighlightText(format(BIB_MONEY_FORMAT, BIBMoney_OutPutMoney(initialMoney)));
	
	-- Money Fluctuation Text
	local fluctMoneyRichText;
	if (fluctMoney < 0) then		
		fluctMoneyRichText = BIB_MONEY_TOOLTIP_LOST.."\t"..
			TitanUtils_GetRedText(format(BIB_MONEY_FORMAT, BIBMoney_OutPutMoney(0 - fluctMoney)));
	elseif (fluctMoney == 0) then
		fluctMoneyRichText = BIB_MONEY_TOOLTIP_EARNED.."\t"..
			TitanUtils_GetHighlightText(format(BIB_MONEY_FORMAT, BIBMoney_OutPutMoney(0)));
	else
		fluctMoneyRichText = BIB_MONEY_TOOLTIP_EARNED.."\t"..
			TitanUtils_GetGreenText(format(BIB_MONEY_FORMAT, BIBMoney_OutPutMoney(fluctMoney)));
	end
	
	BIB_MONEY_TOOLTIP_TEXT = ""..
		currentMoneyRichText.."\n"..
		initialMoneyRichText.."\n"..
		fluctMoneyRichText.."\n"..
		BM_GREEN .. BIB_MONEY_TOOLTIP_HINTS .. BM_FONT_OFF;
end
function BM_Money_OnShow()
	--BM_Money_SetIcon();
end

function BM_Money_SetIcon()
	local icon_gold = BM_GoldIcon;
	local icon_silver = BM_SilverIcon;
	local icon_copper = BM_CopperIcon;

	icon_gold:SetTexture("Interface\\MoneyFrame\\UI-MoneyIcons");
	icon_gold:SetTexCoord(0, 0.25, 0, 1);
	icon_gold:SetWidth(BM_MONEY_ICON_SIZE);
	icon_gold:SetHeight(BM_MONEY_ICON_SIZE);

	icon_silver:SetTexture("Interface\\MoneyFrame\\UI-MoneyIcons");
	icon_silver:SetTexCoord(0.25, 0.5, 0, 1);
	icon_silver:SetWidth(BM_MONEY_ICON_SIZE);
	icon_silver:SetHeight(BM_MONEY_ICON_SIZE);
	
	icon_copper:SetTexture("Interface\\MoneyFrame\\UI-MoneyIcons");
	icon_copper:SetTexCoord(0.5, 0.75, 0, 1);
	icon_copper:SetWidth(BM_MONEY_ICON_SIZE);
	icon_copper:SetHeight(BM_MONEY_ICON_SIZE);
end

function BIBMoney_OutPutMoney(money)
	-- Non-negative money only
	if (money >= 0) then
		local gold = floor(money / (COPPER_PER_SILVER * SILVER_PER_GOLD));
		local silver = floor((money - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER);
		local copper = mod(money, COPPER_PER_SILVER);
		return gold, silver, copper;
	end
end

---**** Options ****---
local BMMoney_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;

BMMoney_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmmoney_ShowIcon",
	pSlashCommand = "BMMoney_Check1_Opt"
};
BMMoney_CheckButtons[ctext2] = {
	id = 2, 
	strVar = "bmmoney_ShowLabel",
	pSlashCommand = "BMMoney_Check2_Opt"
};

function BMMoney_Check1_Opt(msg)
	
end

function BMMoney_Check2_Opt(msg)
	
end

function BM_Money_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMMoney_CheckButtons do
		button = getglobal("BMMoney_Check" .. value.id);
		string = getglobal("BMMoney_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end


function BM_OpenCoinPickupFrame(multiplier, maxMoney, parent)
	if ( CoinPickupFrame.owner ) then
		CoinPickupFrame.owner.hasPickup = 0;
	end

	if ( GetCursorMoney() > 0 ) then
		if ( CoinPickupFrame.owner ) then
			MoneyTypeInfo[parent.moneyType].DropFunc();
			PlaySound("igBackPackCoinSelect");
		end
		CoinPickupFrame:Hide();
		return;
	end

	CoinPickupFrame.multiplier = multiplier;
	CoinPickupFrame.maxMoney = floor(maxMoney / multiplier);
	if ( CoinPickupFrame.maxMoney == 0 ) then
		CoinPickupFrame:Hide();
		return;
	end

	CoinPickupFrame.owner = parent;
	CoinPickupFrame.money = 1;
	CoinPickupFrame.typing = 0;
	CoinPickupText:SetText(CoinPickupFrame.money);
	CoinPickupLeftButton:Disable();
	CoinPickupRightButton:Enable();
	--DEFAULT_CHAT_FRAME:AddMessage(money);
	if ( multiplier == 1 ) then
		CoinPickupCopperIcon:Show();
	else
		CoinPickupCopperIcon:Hide();
	end

	if ( multiplier == COPPER_PER_SILVER ) then
		CoinPickupSilverIcon:Show();
	else
		CoinPickupSilverIcon:Hide();
	end

	if ( multiplier == (COPPER_PER_GOLD) ) then
		CoinPickupGoldIcon:Show();
	else
		CoinPickupGoldIcon:Hide();
	end
	
	if (parent:GetName() == "BM_Money" and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == false) then
		CoinPickupFrame:ClearAllPoints();
		CoinPickupFrame:SetPoint("TOPRIGHT", parent, "BOTTOMRIGHT", 0, -20);
		CoinPickupFrame:Show();
	else
		CoinPickupFrame:ClearAllPoints();
		CoinPickupFrame:SetPoint("BOTTOMRIGHT", parent:GetName(), "TOPRIGHT", 0, 20);
		CoinPickupFrame:Show();
	end
	PlaySound("igBackPackCoinSelect");
end

function BM_Copper_ButtonClick(button)
	if (button == "LeftButton") then
		local parent = this:GetParent();
		parent.moneyType = "PLAYER";
		BM_OpenCoinPickupFrame(1, MoneyTypeInfo[parent.moneyType].UpdateFunc(), parent);
		parent.hasPickup = 1;
	end
end

function BM_Silver_ButtonClick(button)
	if (button == "LeftButton") then
		local parent = this:GetParent();
		parent.moneyType = "PLAYER";
		BM_OpenCoinPickupFrame(COPPER_PER_SILVER, MoneyTypeInfo[parent.moneyType].UpdateFunc(), parent);
		parent.hasPickup = 1;
	end
end

function BM_Gold_ButtonClick(button)
	if (button == "LeftButton") then
		local parent = this:GetParent();
		parent.moneyType = "PLAYER";
		BM_OpenCoinPickupFrame(COPPER_PER_GOLD, MoneyTypeInfo[parent.moneyType].UpdateFunc(), parent);
		parent.hasPickup = 1;
	end
end

--This function is in every plugin always the same except for the 2 varables
function BIB_Money_OnEnter()
	GameTooltip:SetOwner(BM_Money, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), BM_Money, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	-- set the tool tip text 
	--only these two lines will change everything else is the same for all plugins
	GameTooltip:SetText(TitanUtils_GetGreenText(BIB_MONEY_TOOLTIP_TITLE)); -- Usually found in localization file  TITAN_COMBATINFO_TOOLTIP="Combat Info"
	BM_Tooltip_AddTooltipText(BIB_MONEY_TOOLTIP_TEXT); --The variable created by the GetTooltipText() function
	GameTooltip:Show();	
end

--This function is in every plugin always the same
function BIB_Money_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end
