local BM_ZONE_TEXT = "";
local BM_ZONE_TEXT_TOOLTIP = "";
local BM_LOCATION_ID = "bmposition_";

function BM_Position_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("MINIMAP_ZONE_CHANGED");
	this:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	
	PLUG_IN_FRAME = "BM_Position";
	PLUG_IN_NAME = "BM Position";
	BM_ICON_SIZE = BM_LOCATION_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_ICON_SIZE ,BM_LOCATION_ID);
end

function BM_Position_OnEvent()
	if (event == "VARIABLES_LOADED") then		
		BM_Position_initialize();
		return;
	end
	if (event == "MINIMAP_ZONE_CHANGED" or event == "PLAYER_ENTERING_WORLD" or event =="VARIABLES_LOADED" or event == "UNIT_NAME_UPDATE") then
		local zone_Text = GetZoneText();
		local subzone_Text = GetSubZoneText();
		local pvpType, __, __ = GetZonePVPInfo();
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_tooglesubzone) then
			BM_ZONE_TEXT = subzone_Text;
			BM_ZONE_TEXT_TOOLTIP = zone_Text;
		else
			BM_ZONE_TEXT = zone_Text;
			BM_ZONE_TEXT_TOOLTIP = subzone_Text;
		end
		bib_debug(subzone_Text);
		if ( UnitIsPVP("player") == 1 ) then
			BM_FACTION_TEXT="Active";
		else
			BM_FACTION_TEXT="Unflagged";
		end
		if (pvpType) then
			BM_ZONE_TYPE_TEXT = pvpType;
		else
			BM_ZONE_TYPE_TEXT = "Unknown";
		end
	end
	if (event == "ZONE_CHANGED_NEW_AREA") then
		SetMapToCurrentZone();
		BM_ZONE_TEXT = GetZoneText();
		local pvpType, __, __ = GetZonePVPInfo();
		if ( UnitIsPVP("player") == 1 ) then
			BM_FACTION_TEXT="Active";
		else
			BM_FACTION_TEXT="Unflagged";
		end
		if (pvpType) then
			BM_ZONE_TYPE_TEXT = pvpType;
		else
			BM_ZONE_TYPE_TEXT = "Unknown";
		end
	end
	 if (event == "PLAYER_FLAGS_CHANGED") then
		if ( UnitIsPVP("player") == 1 ) then
			BM_FACTION_TEXT="Active";
		else
			BM_FACTION_TEXT="Unflagged";
		end
        end
end

function BM_Position_initialize()
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_ShowLabel == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_ShowLabel = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_TurnOffMapPos == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_TurnOffMapPos = false;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals = false;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_tooglesubzone == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_tooglesubzone = false;
	end
	BM_Position_OnShow();
end

function BM_Position_OnUpdate(arg1)
	BM_LOCATION_REFRESH = BM_LOCATION_REFRESH + arg1;
	if (BM_LOCATION_REFRESH > BM_LOCATION_DELAY) then
		BM_LOCATION_REFRESH = 0.0;
		BM_Position_Refresh();
	end
end

function BM_Position_Refresh()
	local PLAYER_X, PLAYER_Y = GetPlayerMapPosition("player");
	local positionText = "";
	if (BM_ZONE_TYPE_TEXT == "friendly") then
		--BM_ZONE_TYPE_TEXT = "Friendly"
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals) then
			positionText = format(POSITION_TEXT_GREEN_0D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		else
			positionText = format(POSITION_TEXT_GREEN_1D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		end
		BM_POSITION_TOOLTIP_TEXT = "" ..
			BM_LOCATION_ZONE_TEXT .. "\t" .. BM_WHITE .. BM_ZONE_TEXT_TOOLTIP .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_ZONETYPE_TEXT .. "\t" .. BM_GREEN .. BM_ZONE_TYPE_TEXT .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_FACTION_TEXT .. "\t" .. BM_GREEN .. BM_FACTION_TEXT .. BM_FONT_OFF .."\n\n" ..
			BM_POSITION_TOOLTIP_HINT;
	elseif (BM_ZONE_TYPE_TEXT == "hostile") then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals) then
			positionText = format(POSITION_TEXT_RED_0D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		else
			positionText = format(POSITION_TEXT_RED_1D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		end
		BM_POSITION_TOOLTIP_TEXT = "" ..
			BM_LOCATION_ZONE_TEXT .. "\t" .. BM_WHITE .. BM_ZONE_TEXT_TOOLTIP .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_ZONETYPE_TEXT .. "\t" .. BM_RED .. BM_ZONE_TYPE_TEXT .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_FACTION_TEXT .. "\t" .. BM_RED .. BM_FACTION_TEXT .. BM_FONT_OFF .."\n\n" ..
			BM_POSITION_TOOLTIP_HINT;
	elseif (BM_ZONE_TYPE_TEXT == "contested") then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals) then
			positionText = format(POSITION_TEXT_YELLOW_0D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		else
			positionText = format(POSITION_TEXT_YELLOW_1D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		end
		BM_POSITION_TOOLTIP_TEXT = "" ..
			BM_LOCATION_ZONE_TEXT .. "\t" .. BM_WHITE .. BM_ZONE_TEXT_TOOLTIP .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_ZONETYPE_TEXT .. "\t" .. BM_YELLOW .. BM_ZONE_TYPE_TEXT .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_FACTION_TEXT .. "\t" .. BM_YELLOW .. BM_FACTION_TEXT .. BM_FONT_OFF .."\n\n" ..
			BM_POSITION_TOOLTIP_HINT;
	else
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals) then
			positionText = format(POSITION_TEXT_WHITE_0D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		else
			positionText = format(POSITION_TEXT_WHITE_1D, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
		end
		BM_POSITION_TOOLTIP_TEXT = "" ..
			BM_LOCATION_ZONE_TEXT .. "\t" .. BM_WHITE .. BM_ZONE_TEXT_TOOLTIP .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_ZONETYPE_TEXT .. "\t" .. BM_WHITE .. BM_ZONE_TYPE_TEXT .. BM_FONT_OFF .. "\n" ..
			BM_LOCATION_FACTION_TEXT .. "\t" .. BM_WHITE .. BM_FACTION_TEXT .. BM_FONT_OFF .."\n\n" ..
			BM_POSITION_TOOLTIP_HINT;
	end
	if (TitanGetVar(BM_LOCATION_ID, "ShowLabel")) then
			BM_PositionText:SetText(BM_LOCATION_LABEL .. positionText);
		else
			BM_PositionText:SetText(positionText);
		end
	return;
end

function BM_Position_OnClick(button)
	bib_debug("click");
	local PLAYER_X, PLAYER_Y = GetPlayerMapPosition("player");
	local positionText = format(POSITION_TEXT_CHAT, BM_ZONE_TEXT, PLAYER_X *100, PLAYER_Y * 100);
	--local positionText = "(" .. PLAYER_X  .. ", " .. PLAYER_Y  .. ")";
	if (button == "LeftButton") then
		if (ChatFrameEditBox:IsVisible()) then
			message = positionText;
			ChatFrameEditBox:Insert(message);
		end
	end
end

function BM_Position_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	-- set the tool tip text
	GameTooltip:SetText(BM_LOCATION_TOOLTIP_TITLE);
	BM_Tooltip_AddTooltipText(BM_POSITION_TOOLTIP_TEXT);
	GameTooltip:Show();
end

function  BM_Position_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end

function BhaldieInfoBarMapFrame_OnUpdate()
	if (TitanGetVar(BM_LOCATION_ID, "TurnOffMapPos")) then
		BhaldieInfoBarMapCursorCoords:SetText("");
		BhaldieInfoBarMapPlayerCoords:SetText("");
	else
		local x, y = GetCursorPosition();
		x = x / WorldMapFrame:GetScale();
		y = y / WorldMapFrame:GetScale();
		this.px, this.py = GetPlayerMapPosition("player");
		local playerX = 100 * this.px, 100 * this.py;
		local playerY = 100 * this.py;
		local centerX, centerY = WorldMapFrame:GetCenter();
		local width = WorldMapButton:GetWidth();
		local height = WorldMapButton:GetHeight();
		local adjustedX = (x - (centerX - (width/2))) / width;
		local adjustedY = (centerY + (height/2) - y ) / height;
		local cx = (adjustedX);
		local cy = (adjustedY);
		local cursorX = 100 * cx;
		local cursorY = 100 * cy;
		BhaldieInfoBarMapCursorCoords:SetText(format(MAP_CURSOR_POSITION_TEXT, cursorX,cursorY));
		BhaldieInfoBarMapPlayerCoords:SetText(format(MAP_PLAYER_POSITION_TEXT, playerX,playerY));
	end
end

function BM_Position_OnShow()
	BM_Position_SetIcon();
end

function BM_Position_SetIcon()
	local icon = BM_PositionIcon;
	if (TitanGetVar(BM_LOCATION_ID, "ShowIcon")) then
		icon:SetTexture(BM_IMAGE_PATH .. "Icon_position");
		icon:SetWidth(BM_LOCATION_ICON_SIZE);
		icon:SetHeight(BM_LOCATION_ICON_SIZE);
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
end

---**** Options ****---
local BMPosition_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;
local ctext3 = BM_TURN_OFF_POS_MAP;
local ctext4 = BM_LOC_NO_DECIMAL;

BMPosition_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmposition_ShowIcon",
	pSlashCommand = "BMPosition_Check1_Opt"
};
BMPosition_CheckButtons[ctext2] = {
	id = 2, 
	strVar = "bmposition_ShowLabel",
	pSlashCommand = "BMPosition_Check2_Opt"
};
BMPosition_CheckButtons[ctext3] = {
	id = 3, 
	strVar = "bmposition_TurnOffMapPos",
	pSlashCommand = "BMPosition_Check3_Opt"
};
BMPosition_CheckButtons[ctext4] = {
	id = 4, 
	strVar = "bmposition_NoDecimal",
	pSlashCommand = "BMPosition_NoDecimal_Opt"
};
BMPosition_CheckButtons[BM_LOC_SHOWSUBZONE] = {
	id = 5, 
	strVar = "bmposition_tooglesubzone",
	pSlashCommand = "BMPosition_ToogleSubZone_Opt"
};

function BMPosition_Check1_Opt(msg)
	TitanSetVar(BM_LOCATION_ID, "ShowIcon", msg);
	BM_Position_SetIcon();
	BM_Position_Refresh();
end

function BMPosition_Check2_Opt(msg)
	TitanSetVar(BM_LOCATION_ID, "ShowLabel", msg);
	BM_Position_Refresh();
end

function BMPosition_Check3_Opt(msg)
	TitanSetVar(BM_LOCATION_ID, "TurnOffMapPos", msg);
end

function BMPosition_NoDecimal_Opt(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_nodecimals = msg;
end

function BMPosition_ToogleSubZone_Opt(msg)
	local zone_Text = GetZoneText();
	local subzone_Text = GetSubZoneText();
	if (msg) then
		BM_ZONE_TEXT = subzone_Text;
		BM_ZONE_TEXT_TOOLTIP = zone_Text;
	else
		BM_ZONE_TEXT = zone_Text;
		BM_ZONE_TEXT_TOOLTIP = subzone_Text;
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmposition_tooglesubzone = msg;
end

function BM_Position_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMPosition_CheckButtons do
		button = getglobal("BMPosition_Check" .. value.id);
		string = getglobal("BMPosition_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end