local BM_SYSTEM_ID	= "bmsystem_";
function BM_Latency_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	PLUG_IN_FRAME = "BM_System";
	PLUG_IN_NAME = "BM System";
	BM_ICON_SIZE = BM_SYSTEM_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_ICON_SIZE, BM_SYSTEM_ID);
end

function BM_System_OnEvent(event)	
	if (event == "VARIABLES_LOADED") then		
		BM_System_initialize();
		return;
	end
end

function BM_System_initialize()
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_ShowLabel == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_ShowLabel = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidefps == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidefps = false;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidememory == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidememory = false;
	end
	BM_System_OnShow();
end

function BM_Latency_OnUpdate(arg1)
	BM_SYSTEM_REFRESH = BM_SYSTEM_REFRESH + arg1;
	BM_SYSTEM_TIME = BM_SYSTEM_TIME + arg1;
	if (BM_SYSTEM_REFRESH > BM_SYSTEM_DELAY) then
		BM_SYSTEM_REFRESH = 0.0;
		BM_System_Refresh();
	end
end

function BM_System_Refresh()
	-- Gets latancy stats.
	BM_BANDWIDTH_IN, BM_BANDWIDTH_OUT, BM_LATENCY = GetNetStats();
	local latencytext = "";
	local fpstext = "";
	if (BM_LATENCY > 600) then
		latencytext = format(LATENCY_TEXT_RED, BM_LATENCY);
	elseif (BM_LATENCY > 200 and BM_LATENCY < 600) then
		latencytext =  format(LATENCY_TEXT_YELLOW, BM_LATENCY);
	else
		latencytext =  format(LATENCY_TEXT_GREEN, BM_LATENCY);
	end
	--Gets fps stats
	BM_FRAMERATE = GetFramerate()
	BM_FRAME_COUNTER = BM_FRAME_COUNTER + 1;
	if (BM_FRAME_COUNTER == 1) then
		BM_MINFPS = BM_FRAMERATE;
		BM_MAXFPS = BM_FRAMERATE;
		BM_AVGFPS = BM_FRAMERATE;
	else
		if (BM_FRAMERATE < BM_MINFPS) then
			BM_MINFPS = BM_FRAMERATE;
		elseif (BM_FRAMERATE > BM_MAXFPS) then
			BM_MAXFPS = BM_FRAMERATE;
		end
		BM_AVGFPS = (BM_AVGFPS * (BM_FRAME_COUNTER - 1) + BM_FRAMERATE) / BM_FRAME_COUNTER;
	end
	if (BM_FRAMERATE < 10) then
		fpstext = format(FPS_TEXT_RED, BM_FRAMERATE);
	elseif (BM_FRAMERATE < 14 and BM_FRAMERATE > 10) then
		fpstext = format(FPS_TEXT_YELLOW, BM_FRAMERATE);
	else
		fpstext = format(FPS_TEXT_GREEN, BM_FRAMERATE);
	end
	--Get Memory stats.
	BM_PRE_MEM = BM_SYSTEM_MEMORY;
	BM_SYSTEM_MEMORY, BM_SYSTEM_GCT = gcinfo();
	if (BM_PRE_MEM > BM_SYSTEM_MEMORY) then
		BM_SYSTEM_FIRST_RUN = true;
	end
		
	if (BM_SYSTEM_FIRST_RUN) then
		BM_SYSTEM_INT_MEMORY = BM_SYSTEM_MEMORY;
		BM_SYSTEM_TIME = 1;
		BM_SYSTEM_FIRST_RUN = false;
	end
	BM_MEM_INC_RATE = (BM_SYSTEM_MEMORY - BM_SYSTEM_INT_MEMORY) / BM_SYSTEM_TIME;
	--BM_MEM_INC_RATE = BM_SYSTEM_MEMORY - BM_PRE_MEM;
	BM_TIMETO_GC = (BM_SYSTEM_GCT - BM_SYSTEM_MEMORY) / (BM_SYSTEM_MEMORY - BM_SYSTEM_INT_MEMORY) * BM_SYSTEM_TIME;
	--BM_TIMETO_GC = (BM_SYSTEM_GCT - BM_SYSTEM_MEMORY) / (BM_MEM_INC_RATE/1000);
	memorytext = format(BM_MEMORY_TEXT,BM_SYSTEM_MEMORY/1024);
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidefps == true and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidememory == true) then
		BM_SystemText:SetText(latencytext);
	elseif (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidefps == false and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidememory == true) then
		BM_SystemText:SetText(latencytext .. "   " .. fpstext);
	elseif (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidefps == true and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidememory == false) then
		BM_SystemText:SetText(latencytext .. "   " .. memorytext);
	else
		BM_SystemText:SetText(latencytext .. "   " .. fpstext .. "  " .. memorytext);
	end
	BM_System_Tooltip_Text();
	--DEFAULT_CHAT_FRAME:AddMessage(BM_MEM_INC_RATE);
	return;
end

function BM_System_Tooltip_Text()
	if (BM_SYSTEM_ON_BUTTON == true) then
		GameTooltip:SetText(BM_SYSTEM_TOOLTIP_TITLE);
		GameTooltip:AddLine(BM_FPS_TOOLTIP_TITLE);
		GameTooltip:AddDoubleLine(BM_FPS_TOOLTIPTEXT, format(BM_WHITE.. "%.2ffps" .. BM_FONT_OFF, BM_FRAMERATE));
		GameTooltip:AddDoubleLine(BM_AVGFPS_TOOLTIPTEXT, format(BM_WHITE.. "%.2ffps"  .. BM_FONT_OFF, BM_AVGFPS));
		GameTooltip:AddDoubleLine(BM_MINFPS_TOOLTIPTEXT, format(BM_WHITE.. "%.2ffps"  .. BM_FONT_OFF, BM_MINFPS));
		GameTooltip:AddDoubleLine(BM_MAXFPS_TOOLTIPTEXT, format(BM_WHITE.. "%.2ffps"  .. BM_FONT_OFF, BM_MAXFPS));
		GameTooltip:AddLine(BM_LATENCY_TOOLTIP_TITLE);
		GameTooltip:AddDoubleLine(BM_LATENCY_TOOLTIPTEXT, format(BM_WHITE.. "%dms" .. BM_FONT_OFF, BM_LATENCY));
		GameTooltip:AddDoubleLine(BM_BANDIN_TOOLTIPTEXT, format(BM_WHITE.. "%.3fkb/s" .. BM_FONT_OFF, BM_BANDWIDTH_IN));
		GameTooltip:AddDoubleLine(BM_BANDOUT_TOOLTIPTEXT, format(BM_WHITE.. "%.3fkb/s" .. BM_FONT_OFF, BM_BANDWIDTH_OUT));
		GameTooltip:AddLine(BM_MEMORY_TOOLTIP_TITLE);
		GameTooltip:AddDoubleLine(BM_MEM_TOOLTIPTEXT, format(BM_WHITE.. "%.2fmb" .. BM_FONT_OFF, BM_SYSTEM_MEMORY/1024));
		GameTooltip:AddDoubleLine(BM_INT_MEM_TOOLTIPTEXT, format(BM_WHITE.. "%.2fmb" .. BM_FONT_OFF, BM_SYSTEM_INT_MEMORY/1024));
		GameTooltip:AddDoubleLine(BM_MEM_INC_TOOLTIPTEXT, format(BM_WHITE.. "%.2fkb/s" .. BM_FONT_OFF, BM_MEM_INC_RATE));
		GameTooltip:AddLine(BM_GC_TOOLTIP_TITLE);
		GameTooltip:AddDoubleLine(BM_GC_TOOLTIPTEXT, format(BM_WHITE.. "%.2fmb" .. BM_FONT_OFF, BM_SYSTEM_GCT/1024));
		GameTooltip:AddDoubleLine(BM_GC_TIMETO_TOOLTIPTEXT, format(BM_WHITE.. "%s" .. BM_FONT_OFF, BM_GetTime(BM_TIMETO_GC)));
		GameTooltip:Show();		
	end
end

function BM_System_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	BM_SYSTEM_ON_BUTTON = true;
end

function BM_System_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
	BM_SYSTEM_ON_BUTTON = false;
end

function BM_System_OnShow()
	BM_System_SetIcon();
end

function BM_System_SetIcon()
	local icon = BM_SystemIcon;
	if (TitanGetVar(BM_SYSTEM_ID, "ShowIcon")) then
		icon:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Icon_system");
		icon:SetWidth(BM_SYSTEM_ICON_SIZE);
		icon:SetHeight(BM_SYSTEM_ICON_SIZE);
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
end


---**** Options ****---
local BMSystem_CheckButtons = { };
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;

BMSystem_CheckButtons[ctext1] = {
	id = 1,
	strVar = "bmsystem_ShowIcon",
	pSlashCommand = "BMSystem_Check1_Opt"
};
BMSystem_CheckButtons[ctext2] = {
	id = 2, 
	strVar = "bmsystem_showlabel",
	pSlashCommand = "BMSystem_Check2_Opt"
};
BMSystem_CheckButtons[BMSYSTEM_HIDE_FPS] = {
	id = 3, 
	strVar = "bmsystem_hidefps",
	pSlashCommand = "BMSystem_Check3_Opt"
};
BMSystem_CheckButtons[BMSYSTEM__HIDE_MEMORY] = {
	id = 4, 
	strVar = "bmsystem_hidememory",
	pSlashCommand = "BMSystem_Check4_Opt"
};

function BMSystem_Check1_Opt(msg)
	TitanSetVar(BM_SYSTEM_ID, "ShowIcon", msg);
	BM_System_SetIcon();
	BM_System_Refresh();
end

function BMSystem_Check2_Opt(msg)
	
end

function BMSystem_Check3_Opt(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidefps = msg;
end

function BMSystem_Check4_Opt(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].bmsystem_hidememory = msg;
end

function BM_System_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMSystem_CheckButtons do
		button = getglobal("BMSystem_Check" .. value.id);
		string = getglobal("BMSystem_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Item Checked: " .. button);
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
end