-- ***Slash command functions*** --
-- define the dialog box for reseting config
StaticPopupDialogs["BM_INFO_BAR_REST"] = {
	text = TEXT(BM_RESET_ALL_TEXT),
	button1 = TEXT(OKAY),
	button2 = TEXT(CANCEL),
	OnAccept = function()
		--BM_Reset_Everything();
		--BhaldieMoveIT_Refresh();
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM] = {};
		ReloadUI();
	end,
	timeout = 0,
	exclusive = 1
};

function BM_InfoBar_Reset()
	StaticPopup_Show("BM_INFO_BAR_REST");
end

function BM_Slash_OnLoad()
	-- Slash commands for debugging on and off.
	SlashCmdList["BM_DEBUG"] = BM_Debug_SlashHandler;
	SLASH_BM_DEBUG1 = "/bmdebug";

	-- Slash commands for infobar config menu.
	SlashCmdList["BM_UI_PANEL"] = BM_UI_Panel_SlashHandler;
	SLASH_BM_UI_PANEL1 = "/bmconfig";

	--[[
	-- Slash commands for infobar.
	SlashCmdList["BM_INFOBAR"] = BM_InfoBar_SlashHandler;
	SLASH_BM_INFOBAR1 = "/bminfo";

	-- Slash commands for infobar.
	SlashCmdList["BM_ALPHA"] = BM_Alpha_SlashHandler;
	SLASH_BM_ALPHA1 = "/bmalpha";

	-- Slash commands for infobar time offset.
	SlashCmdList["BM_TIMEOFFSET"] = BM_TimeOffset_SlashHandler;
	SLASH_BM_TIMEOFFSET1 = "/bmtime";
	
	-- Slash commands for infobar time offset.
	SlashCmdList["BM_RESET"] = BM_Reset_SlashHandler;
	SLASH_BM_RESET1 = "/bmreset";
	--]]
end


function BM_Debug_SlashHandler(msg)
	bib_debug("In");
	BHINFOBAR_CONFIG.bib_debug = msg;
end


function BM_UI_Panel_SlashHandler()
	if (IsAddOnLoaded("BhaldieUI")) then
		BM_LogoButton_OnClick();
	end
end

--[[ Control the slash commands for the Info Bar.
function BM_InfoBar_SlashHandler(msg)
	msg = string.lower(msg);
	if (msg == "enable") then
		-- Enable info bar
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_enable = true;
		BhaldieInfoBar:ClearAllPoints();
		BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -10, 8);
		BM_INFO_ENABLE = true;
		BhaldieInfoBar:Show();
		-- Moves the minimap, player, party, pet, and target frames down to allow the info bar to be placed.
		MinimapCluster:ClearAllPoints();
		MinimapCluster:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -10, BM_UNIT_BUFF_FRAMES_Y);
		PlayerFrame:ClearAllPoints();
		PlayerFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -19, BM_UNIT_BUFF_FRAMES_Y);
		PartyMemberFrame1:ClearAllPoints();
		PartyMemberFrame1:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 10, BM_PARTY_FRAME_Y);
		TargetFrame:ClearAllPoints();
		TargetFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 250, BM_UNIT_BUFF_FRAMES_Y);
	elseif (msg == "disable") then
		-- Disable info bar
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_enable = false;
		BM_INFO_ENABLE = false;
		BhaldieInfoBar:ClearAllPoints();
		BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -10, 50);
		BhaldieInfoBar:Hide();
		StaticPopup_Show("BM_INFO_BAR_RESET");
	end
end]]

-- Control the slash commands for the Info Bars alpha.
function BM_Alpha_SlashHandler(msg)
	
	--msg = string.lower(msg);
	if (msg < 0 or msg > 1) then
		--UIErrorsFrame:AddMessage("Number must be between 0 and 1.", 1.0, 0.0, 0.0, 1.0, UIERRORS_HOLD_TIME);
	else
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha = msg;
		bib_debug("Test Entered Alpha " ..  msg);
		--[[
		BhaldieInfoBarBG1:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		BhaldieInfoBarBG2:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		BhaldieInfoBarBG3:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		BhaldieInfoBarBG4:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		]]
		BIB_Background:SetAlpha(msg);
	end
end

function BM_Plugin_Enable(msg, id)
	if (msg == false) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][id].enable = false;
		local BM_TEMP
		BM_TEMP = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][id].position;
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][id].position = PLUG_IN_COUNT-1;
		for i=1,  PLUG_IN_COUNT-1, 1 do
			if (id ~= i) then
				if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].position > BM_TEMP) then
					BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].position = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].position - 1;
				end
			end
		end
	elseif (msg == true) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][id].enable = true;
		local BM_TEMP
		BM_TEMP = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][id].position;
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][id].position = PLUG_IN_COUNT-1;
		for i=1,  PLUG_IN_COUNT-1, 1 do
			if (id ~= i) then
				if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].position > BM_TEMP) then
					BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].position = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].position - 1;
				end
			end
		end
	end
	Refresh_Plugins();
end

function BM_XP_Info_Enable(msg)
	if (msg == true) then
		BhaldieInfoBarXPText:Show();
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].xp_info = true;
	else
		BhaldieInfoBarXPText:Hide();
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].xp_info = false;
	end
end

function BM_InfoBar_Enable(msg)
	if (msg == false) then
		msg = "disable";
		--BM_InfoBar_SlashHandler(msg)
	elseif (msg == true) then
		msg = "enable";
		--BM_InfoBar_SlashHandler(msg)
	end
end

function BM_XPBar_Scale(msg)
	--BhaldieCurrentXPBar:SetWidth(msg);
	--BhaldieRestXPBar:SetWidth(msg);
	--BhaldieInfoBarXPTexture:SetWidth(msg);
	--BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale = msg;
	--BM_BG_WIDTH = msg;
	BIB_Background:SetWidth(UI_PARENT_WIDTH-50+msg);
	BhaldieCurrentXPBar:SetWidth(UI_PARENT_WIDTH-60+msg);
	BhaldieRestXPBar:SetWidth(UI_PARENT_WIDTH-60+msg);
	BhaldieInfoBarXPTexture:SetWidth(UI_PARENT_WIDTH-60+msg);
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale = msg;

	--BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].height_offset = msg;
	--Refresh_Plugins();
end

function BM_Plugin_XSpace(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_xspace = msg;
	Refresh_Plugins();
end

function BM_Plugin_FontSize(msg)
	local uiscale = 1;
	--local uiscale = UIParent:GetScale();
	for key, value in BIB_FONTS do
		bib_debug(value.code);
		getglobal(value.code):SetFont(value.font_type, msg);
	end
	for key, value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
		if (value.framename == "BM_Money") then
			BM_GoldText:SetTextHeight(msg);
			BM_Gold:SetScale(2);
			BM_Gold:SetScale(uiscale);
			BM_SilverText:SetTextHeight(msg);
			BM_Silver:SetScale(2);
			BM_Silver:SetScale(uiscale);
			--Olive:SetFont(BM_Copper:GetFont(), msg);
			--bib_debug(BM_Copper:GetFont());
			--BM_CopperText:SetTextHeight(msg);
			BM_Copper:SetScale(2);
			BM_Copper:SetScale(uiscale);
		else
			local button = "TitanPanel".. value.id .. "Button";
			if (getglobal(button)) then
				if (getglobal(button).registry) then
					if (getglobal(button).registry.hasChild) then
						for childkey, childvalue in getglobal(button).registry.childButtonNames do
							getglobal(childvalue .. "Text"):SetTextHeight(msg);
							getglobal(childvalue):SetScale(2);
							getglobal(childvalue):SetScale(uiscale);
							--getglobal(childvalue):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
							--bib_debug(childvalue);
						end
						getglobal(value.framename .. "Text"):SetTextHeight(msg);
						getglobal(value.framename):SetScale(2);
						getglobal(value.framename):SetScale(uiscale);
						--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					else
						getglobal(value.framename .. "Text"):SetTextHeight(msg);
						getglobal(value.framename):SetScale(2);
						getglobal(value.framename):SetScale(uiscale);
						--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					end
				else
					getglobal(value.framename .. "Text"):SetTextHeight(msg);
					getglobal(value.framename):SetScale(2);
					getglobal(value.framename):SetScale(uiscale);
					--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
				end
			else
				getglobal(value.framename .. "Text"):SetTextHeight(msg);
				getglobal(value.framename):SetScale(2);
				getglobal(value.framename):SetScale(uiscale);
				--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
			end
			
			--getglobal(value.framename .. "Text"):SetTextHeight(msg);
			--getglobal(value.framename):SetScale(2);
			--getglobal(value.framename):SetScale(uiscale);
		end
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize = msg;
	Refresh_Plugins();
end

function BM_Infobar_Invert(msg)
	if (msg == true) then
		--BhaldieInfoBar:ClearAllPoints();
		--BhaldieInfoBar:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", 0, 0);
		BhaldieInfoBarBG1:ClearAllPoints();
		BhaldieInfoBarBG1:SetPoint("BOTTOMLEFT", "BhaldieInfoBar", "BOTTOMLEFT", 0, -24);
		--[[
		BhaldieInfoBarBG1:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar1");
		BhaldieInfoBarBG2:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar2");
		BhaldieInfoBarBG3:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar3");
		BhaldieInfoBarBG4:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar4");
		]]
		BIB_Background:ClearAllPoints();
		BIB_Background:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, -20);
		BIB_PluginFrame1:ClearAllPoints();
		BIB_PluginFrame1:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
		BIB_PluginFrame2:ClearAllPoints();
		BIB_PluginFrame2:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
		BIB_PluginFrame3:ClearAllPoints();
		BIB_PluginFrame3:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
		BIB_PluginFrame4:ClearAllPoints();
		BIB_PluginFrame4:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
		BIB_PluginFrame5:ClearAllPoints();
		BIB_PluginFrame5:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
		BIB_PluginFrame6:ClearAllPoints();
		BIB_PluginFrame6:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
		BhaldieInfoBarLogoFrame:ClearAllPoints();
		BhaldieInfoBarLogoFrame:SetPoint("CENTER", "BIB_Background", "TOPLEFT", 15, -8);
		BhaldieCurrentXPBar:ClearAllPoints();
		BhaldieCurrentXPBar:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 5);
		BhaldieInfoBar:Show();
		-- Moves the minimap, player, party, pet, and target frames down to allow the info bar to be placed.
		MinimapCluster:ClearAllPoints();
		MinimapCluster:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", 0, 0);
		TicketStatusFrame:ClearAllPoints();
		TicketStatusFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -180, 0);
		if (not IsAddOnLoaded("DiscordActionBars") and not IsAddOnLoaded("Nurfed_ActionBars")) then
			MainMenuBar:ClearAllPoints();
			MainMenuBar:SetPoint("BOTTOM", "BhaldieInfoBarBG2", "TOPRIGHT", 0, 0);
		end
		--BIB_ToogleMainMenuTexture();
		if (not IsAddOnLoaded("CT_UnitFrames") and not IsAddOnLoaded("Gypsy_UnitBars")  and not IsAddOnLoaded("DiscordUnitFrames")) then
			PlayerFrame:ClearAllPoints();
			PlayerFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -19, -4);
			PartyMemberFrame1:ClearAllPoints();
			PartyMemberFrame1:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 10, -128);
			TargetFrame:ClearAllPoints();
			TargetFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 250, -4);
		end
		BM_TOOLTIP_ANCHOR = "BOTTOM";
		BM_TOOLTIP_RELPOINT = "TOP";
	else
		--BhaldieInfoBar:ClearAllPoints();
		--BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -10, 8);
		BhaldieInfoBarBG1:ClearAllPoints();
		BhaldieInfoBarBG1:SetPoint("TOPLEFT", "BhaldieInfoBar", "TOPLEFT", 0, 18);
		--[[
		BhaldieInfoBarBG1:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar1");
		BhaldieInfoBarBG2:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar2");
		BhaldieInfoBarBG3:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar3");
		BhaldieInfoBarBG4:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar4");
		]]
		BIB_Background:ClearAllPoints();
		BIB_Background:SetPoint("TOP", "BhaldieInfoBar", "TOP", 10, 14);
		BIB_PluginFrame1:ClearAllPoints();
		BIB_PluginFrame1:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
		BIB_PluginFrame2:ClearAllPoints();
		BIB_PluginFrame2:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
		BIB_PluginFrame3:ClearAllPoints();
		BIB_PluginFrame3:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
		BIB_PluginFrame4:ClearAllPoints();
		BIB_PluginFrame4:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
		BIB_PluginFrame5:ClearAllPoints();
		BIB_PluginFrame5:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
		BIB_PluginFrame6:ClearAllPoints();
		BIB_PluginFrame6:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
		BhaldieInfoBarLogoFrame:ClearAllPoints();
		BhaldieInfoBarLogoFrame:SetPoint("CENTER", "BIB_Background", "BOTTOMLEFT", 13, 8);
		BhaldieCurrentXPBar:ClearAllPoints();
		BhaldieCurrentXPBar:SetPoint("TOP", "BhaldieInfoBar", "TOP", 10, -8);
		BhaldieInfoBar:Show();
		-- Moves the minimap, player, party, pet, and target frames down to allow the info bar to be placed.
		MinimapCluster:ClearAllPoints();
		MinimapCluster:SetPoint("TOPRIGHT", "BhaldieInfoBarBG4", "BOTTOMRIGHT", 10, -10);
		TicketStatusFrame:ClearAllPoints();
		TicketStatusFrame:SetPoint("TOPRIGHT", "BhaldieInfoBarBG4", "BOTTOMRIGHT", -180, 0);
		if (not IsAddOnLoaded("DiscordActionBars") and not IsAddOnLoaded("Nurfed_ActionBars")) then
			MainMenuBar:ClearAllPoints();
			MainMenuBar:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, 0);
		end
		--BIB_ToogleMainMenuTexture()
		if (not IsAddOnLoaded("CT_UnitFrames") and not IsAddOnLoaded("Gypsy_UnitBars")  and not IsAddOnLoaded("DiscordUnitFrames")) then
			PlayerFrame:ClearAllPoints();
			PlayerFrame:SetPoint("TOPLEFT", "BhaldieInfoBarBG1", "BOTTOMLEFT", -19, -14);
			PartyMemberFrame1:ClearAllPoints();
			PartyMemberFrame1:SetPoint("TOPLEFT", "BhaldieInfoBarBG1", "BOTTOMLEFT", 10, -138);
			TargetFrame:ClearAllPoints();
			TargetFrame:SetPoint("TOPLEFT", "BhaldieInfoBarBG1", "BOTTOMLEFT", 250, -14);
		end
		BM_TOOLTIP_ANCHOR = "TOP";
		BM_TOOLTIP_RELPOINT = "BOTTOM";
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert = msg;
	Refresh_Plugins();
end

function BM_Infobar_HideXP(msg)
	if (msg == true) then
		BhaldieCurrentXPBar:Show();
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].showrepbar) then
			BhaldieRestXPBar:Hide();
		else
			bib_debug("IN");
			BhaldieRestXPBar:Show();
		end
		BM_INFO_XPBAR_OFFSET = -4;
	else
		BhaldieCurrentXPBar:Hide();
		BhaldieRestXPBar:Hide();
		BM_INFO_XPBAR_OFFSET = -15;
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp = msg;
	Refresh_Plugins();
end

function BM_Infobar_HideLogo(msg)
	if (msg == true) then
		BhaldieInfoBarLogoFrame:SetAlpha(100);
	else
		BhaldieInfoBarLogoFrame:SetAlpha(0);
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidelogo = msg;
end

function BM_Center_Plugins(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].center_plugins = msg;
end

--Custom Font Functions
function BIB_FontDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BIB_FontDropDown_Initialize);
	UIDropDownMenu_SetWidth(140, BIB_FontDropDown);
	UIDropDownMenu_SetSelectedValue(BIB_FontDropDown, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
end

function BIB_FontDropDown_Initialize()
	local i, info;
	for i=0, table.getn(BIB_FONTS)  do
		info = {};
		info.text = BIB_FONTS[i].name;
		info.value = BIB_FONTS[i].code;
		info.func = BIB_FontDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end

function BIB_FontDropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(BIB_FontDropDown, this.value);
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode = this.value;
	BIB_ChangeFont(this.value, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
end

function BIB_ChangeFont(fontType, fontHeight)
	bib_debug(fontType);
	for key, value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
		if (value.framename == "BM_Money") then
			BM_Gold:SetTextFontObject(fontType);
			BM_Silver:SetTextFontObject(fontType);
			BM_Copper:SetTextFontObject(fontType);
			--BM_Gold:SetFont(fontPath, fontHeight);
			--BM_Silver:SetFont(fontPath, fontHeight);
			--BM_Copper:SetFont(fontPath, fontHeight);
		else
			local button = "TitanPanel".. value.id .. "Button";
			if (getglobal(button)) then
				if (getglobal(button).registry) then
					if (getglobal(button).registry.hasChild) then
						for childkey, childvalue in getglobal(button).registry.childButtonNames do
							getglobal(childvalue):SetTextFontObject(fontType);
							--getglobal(childvalue):SetFont(fontPath, fontHeight);
						end
						getglobal(value.framename):SetTextFontObject(fontType);
						--getglobal(value.framename):SetFont(fontPath, fontHeight);
					else
						getglobal(value.framename):SetTextFontObject(fontType);
						--getglobal(value.framename):SetFont(fontPath, fontHeight);
					end
				else
					getglobal(value.framename):SetTextFontObject(fontType);
					--getglobal(value.framename):SetFont(fontPath, fontHeight);
				end
			else
				getglobal(value.framename):SetTextFontObject(fontType);
				--getglobal(value.framename):SetFont(fontPath, fontHeight);
			end
		end
	end
end

--Profile Functions
function BIB_ProfileDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, BIB_ProfileDropDown_Initialize);
	--UIDropDownMenu_SetWidth(140, BIB_FontDropDown);
	--UIDropDownMenu_SetSelectedValue(BIB_ProfileDropDown, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].profile);
end

function BIB_ProfileDropDown_Initialize()
	local BIB_Profiles = {};
	local i, info;
	for key, value in BHINFOBAR_CONFIG["Profiles"] do
		bib_debug(key);
		--BIB_Profiles[key] = {name=value, type=value};
		info = {};
		info.text = key;
		info.value = key;
		info.func = BIB_ProfileDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
	--[[
	local i, info;
	for i=0, table.getn(BIB_Profiles)  do
		info = {};
		info.text = BIB_Profiles[i].name;
		info.value = BIB_Profiles[i].type;
		info.func = BIB_ProfileDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end]]
end

function BIB_ProfileDropDown_OnClick()
	UIDropDownMenu_SetSelectedValue(BIB_ProfileDropDown, this.value);
	--BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType = this.value;
	--BIB_ChangeFont(this.value, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
end

function BIB_LoadProfile(fontType, fontHeight)
	local fontPath = fontType;
	for key, value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
		if (value.framename == "BM_Money") then
			BM_Gold:SetFont(fontPath, fontHeight);
			BM_Silver:SetFont(fontPath, fontHeight);
			BM_Copper:SetFont(fontPath, fontHeight);
		else			
			getglobal(value.framename):SetFont(fontPath, fontHeight);
		end
	end
end

--[[
function BIB_ToogleMainMenuTexture(msg)
	if (msg == true) then
		MainMenuBarTexture0:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture0:SetTexCoord(0, 1.0, 0.79296875, 1.0);
		MainMenuBarTexture1:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture1:SetTexCoord(0, 1.0, 0.54296875, 0.75);
		MainMenuBarTexture2:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture2:SetTexCoord(0, 1.0, 0.29296875, 0.5);
		MainMenuBarTexture3:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture3:SetTexCoord(0, 1.0, 0.04296875, 0.25);
		MainMenuExpBar:SetWidth(0.0001);
		MainMenuBarPerformanceBarFrame:ClearAllPoints();
		MainMenuBarPerformanceBarFrame:SetPoint("BOTTOMRIGHT", "MainMenuBar", "BOTTOMRIGHT", -227, -10);
	else
		MainMenuBarTexture0:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture0:SetTexCoord(0, 1.0, 0.79296875, 1.0);
		MainMenuBarTexture1:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture1:SetTexCoord(0, 1.0, 0.54296875, 0.75);
		MainMenuBarTexture2:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture2:SetTexCoord(0, 1.0, 0.29296875, 0.5);
		MainMenuBarTexture3:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture3:SetTexCoord(0, 1.0, 0.04296875, 0.25);
		MainMenuExpBar:SetWidth(1024);
		MainMenuBarPerformanceBarFrame:ClearAllPoints();
		MainMenuBarPerformanceBarFrame:SetPoint("BOTTOMRIGHT", "MainMenuExpBar", "BOTTOMRIGHT", -227, -50);
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp = msg;
	BM_PetActionBar_UpdatePosition();
	BM_ShapeshiftBar_UpdatePosition();
end
]]

function BIB_ToogleAutoHide(msg)
	--[[
	bib_debug(BhaldieInfoBarBG1:GetHeight());
	if (msg == true) then
		BhaldieInfoBar:ClearAllPoints();
		BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -10, BhaldieInfoBarBG1:GetHeight()-20);
	else
		BhaldieInfoBar:ClearAllPoints();
		BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",  -10, 8);
	end	]]
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].autohide = msg;
end

function BIB_ShowRepBar(msg)
	bib_debug("Entered");
	if (msg) then
		bib_debug("Entered true");
		local name, reaction, min, max, value = GetWatchedFactionInfo();
		if (name) then
			-- Normalize values
			max = max - min;
			value = value - min;
			min = 0;
			BhaldieCurrentXPBar:SetMinMaxValues(min, max);
			BhaldieCurrentXPBar:SetValue(value);
			BhaldieInfoBarXPText:SetText(name.." "..value.." / "..max);
			local color = FACTION_BAR_COLORS[reaction];
			BhaldieCurrentXPBar:SetStatusBarColor(color.r, color.g, color.b);
			BhaldieRestXPBar:Hide();
		end
	else
		bib_debug("Entered false");
		-- Creates xp bars for infobar
		BhaldieCurrXP = UnitXP("player");
		BhaldieMaxXP = UnitXPMax("player");
		BhaldieRestXP = GetXPExhaustion();
		BhaldieCurrentXPBar:SetMinMaxValues(0, BhaldieMaxXP);
		BhaldieRestXPBar:SetMinMaxValues(0, BhaldieMaxXP);
		BhaldieCurrentXPBar:SetValue(BhaldieCurrXP);
		if (BhaldieRestXP ~= nil and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp == true) then
			BhaldieRestXPBar:Show();
			BhaldieRestXPBar:SetValue(BhaldieCurrXP + BhaldieRestXP);
			BhaldieCurrentXPBar:SetStatusBarColor(0.22, 0.39, 1.0, 1.0);
			BhaldieRestXPBar:SetStatusBarColor(0.0, 1.0, 0.39, 0.60);
			--BhaldieRestXPBar:SetStatusBarColor(0.0, 0.54, 0.57, 0.75);
		else 
			BhaldieRestXP = 0;
			BhaldieRestXPBar:Hide();
			BhaldieCurrentXPBar:SetStatusBarColor(0.58, 0.0, 0.55, 1.0);
		end
		BhaldieInfoBarXPText:SetText(format(XP_TEXT_WHITE, BhaldieCurrXP, BhaldieMaxXP, BhaldieRestXP));
	end
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].showrepbar = msg;
end

function BIB_ToogleRep_Tooltip_Show()
	-- put the tool tip in the default position
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint("BOTTOMLEFT", this, "TOPRIGHT", 0, 0);
	-- set the tool tip text
	GameTooltip:SetText(BM_GREEN .. BM_REP_TOOLTIP_TITLE.. BM_FONT_OFF);
	GameTooltip:AddLine(BM_WHITE .. BM_REP_TOOLTIP_TEXT .. BM_FONT_OFF);
	GameTooltip:Show();
end

function BIB_ToogleRep_Tooltip_Leave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end